public with sharing class TestSignerAuthentication {
    public ESignLiveAPIObjects.Role createSignerWithAuthentication_QA(String id, String firstName, String lastName, String email, String firstQuestion, String firstQuestionAnswer, String secondQuestion, String secondQuestionAnswer){
    	ESignLiveAPIObjects.Role role = new ESignLiveAPIObjects.Role();
    	ESignLiveAPIObjects.AuthChallenge firstChallenge = new ESignLiveAPIObjects.AuthChallenge(firstQuestionAnswer, false, firstQuestion);
    	ESignLiveAPIObjects.AuthChallenge secondChallenge = new ESignLiveAPIObjects.AuthChallenge(secondQuestionAnswer, false, secondQuestion);
    	ESignLiveAPIObjects.Auth auth = new ESignLiveAPIObjects.Auth(new List<ESignLiveAPIObjects.AuthChallenge>{firstChallenge,secondChallenge}, ESignLiveAPIObjects.AuthScheme.CHALLENGE);
    	
        ESignLiveValidation.validate('Email', email);
        ESignLiveValidation.validate('First Name', firstname);
        ESignLiveValidation.validate('Last Name', lastname);
        ESignLiveValidation.validate(firstChallenge);
        ESignLiveValidation.validate(secondChallenge);
        
        ESignLiveAPIObjects.Signer signer = new ESignLiveAPIObjects.Signer();
        signer.firstName = firstName;
        signer.lastName = lastName;
        signer.email = email;
        signer.name = firstName + lastName;
        signer.id = id;
        signer.auth = auth;

        role.signers = new List<ESignLiveAPIObjects.Signer>{signer};
        role.id = id;
        
        return role;   
    }
    
    
     public ESignLiveAPIObjects.Role createSignerWithAuthentication_SMS(String id, String firstName, String lastName, String email, String phoneNumber){
    	ESignLiveAPIObjects.Role role = new ESignLiveAPIObjects.Role();
    	ESignLiveAPIObjects.AuthChallenge smsAuthentication = new ESignLiveAPIObjects.AuthChallenge(null, false, phoneNumber);
    	ESignLiveAPIObjects.Auth auth = new ESignLiveAPIObjects.Auth(new List<ESignLiveAPIObjects.AuthChallenge>{smsAuthentication}, ESignLiveAPIObjects.AuthScheme.SMS);
    	
        ESignLiveValidation.validate('Email', email);
        ESignLiveValidation.validate('First Name', firstname);
        ESignLiveValidation.validate('Last Name', lastname);
        
        ESignLiveAPIObjects.Signer signer = new ESignLiveAPIObjects.Signer();
        signer.firstName = firstName;
        signer.lastName = lastName;
        signer.email = email;
        signer.name = firstName + lastName;
        signer.id = id;
        signer.auth = auth;

        role.signers = new List<ESignLiveAPIObjects.Signer>{signer};
        role.id = id;
        
        return role;  
    }
    
    public void createRoleWithKBA_EquifaxUSA(String packageId, String roleId, String firstName, String lastName, String email, String streetAddress, 
    								String city, String zip, String state, Integer timeAtAddress, String driversLicenseNumber, String dateOfBirth, String socialSecurityNumber, String homePhoneNumber){
	    String payload = '{ '+
	    				     '  "id":"'+roleId+'",'+
							 '  "signers":[ '+
							 '     { '+
							 '        "id":"'+roleId+'",'+
							 '        "email":"'+email+'",'+
							 '        "firstName":"'+firstName+'",'+
							 '        "lastName":"'+lastName+'",'+
							 '        "knowledgeBasedAuthentication":{ '+
							 '           "signerInformationForEquifaxUSA":{ '+
							 '             "firstName":"'+firstName+'",'+
							 '              "lastName":"'+lastName+'",'+
							 '              "streetAddress":"'+streetAddress+'",'+
							 '              "city":"'+city+'",'+
							 '              "zip":"'+zip+'",'+
							 '              "state":"'+state+'",'+
							 '              "timeAtAddress":'+timeAtAddress+','+
							 '              "driversLicenseNumber":"'+driversLicenseNumber+'",'+
							 '              "dateOfBirth":"'+dateOfBirth+'",'+
							 '              "socialSecurityNumber":"'+socialSecurityNumber+'",'+
							 '              "homePhoneNumber":"'+homePhoneNumber+'"'+
							 '          }'+
							 '        }'+
							 '     }'+
							 '  ],'+
							'}';
    
    	String resourceUrl = '/packages/'+packageId+'/roles';
        HttpResponse response = doPost(resourceUrl, payload);
		
        // Check response
        if(response.getStatusCode() != 200)
        {
            throw new ESignLiveRESTAPIHelper.ESignLiveRestAPIHelperException('Error create Role With KBA_EquifaxUSA ' + response.getStatusCode() + ' - ' + response.getStatus() + ' - ' +  response.getBody());
        }
    }
    
    
    //new TestSignerAuthentication().createRoleWithKBA_EquifaxUSA('qUoYpvWHQNI44lTmDccqL69ZzDM=', 'signer3', 'signer3 firstname', 'signer3 lastname', 'signer3@mailinator.com', '2020 Broadway Street', 
    //								'new york', '12345', 'NY', 5, '1234567890', '1969-12-09T00:00:00Z', '123456789', '');
    public void createRoleWithKBA_EquifaxCA(String packageId, String roleId, String firstName, String lastName, String email, String streetAddress, 
    								String city, String zip, String state, Integer timeAtAddress, String driversLicenseNumber, String dateOfBirth, String socialSecurityNumber, String homePhoneNumber){
	    String payload = '{ '+
	    				     '  "id":"'+roleId+'",'+
							 '  "signers":[ '+
							 '     { '+
							 '        "id":"'+roleId+'",'+
							 '        "email":"'+email+'",'+
							 '        "firstName":"'+firstName+'",'+
							 '        "lastName":"'+lastName+'",'+
							 '        "knowledgeBasedAuthentication":{ '+
							 '           "signerInformationForEquifaxCanada":{ '+
							 '             "firstName":"'+firstName+'",'+
							 '              "lastName":"'+lastName+'",'+
							 '              "streetAddress":"'+streetAddress+'",'+
							 '              "city":"'+city+'",'+
							 '              "zip":"'+zip+'",'+
							 '              "state":"'+state+'",'+
							 '              "timeAtAddress":'+timeAtAddress+','+
							 '              "driversLicenseNumber":"'+driversLicenseNumber+'",'+
							 '              "dateOfBirth":"'+dateOfBirth+'",'+
							 '              "socialSecurityNumber":"'+socialSecurityNumber+'",'+
							 '              "homePhoneNumber":"'+homePhoneNumber+'"'+
							 '          }'+
							 '        }'+
							 '     }'+
							 '  ],'+
							'}';
    
    
    	System.debug('payload: '+ payload);
    	String resourceUrl = '/packages/'+packageId+'/roles';
        HttpResponse response = doPost(resourceUrl, payload);
		
        // Check response
        if(response.getStatusCode() != 200)
        {
            throw new ESignLiveRESTAPIHelper.ESignLiveRestAPIHelperException('Error create Role With KBA_EquifaxUSA ' + response.getStatusCode() + ' - ' + response.getStatus() + ' - ' +  response.getBody());
        }
    }
    
    
    public void sendSmsToSigner(String packageId, String roleId){
    	String resourceUrl = '/packages/'+packageId+'/roles/'+roleId+'/sms_notification';
        HttpResponse response = doPost(resourceUrl, '');
		
        // Check response
        if(response.getStatusCode() != 200)
        {
            throw new ESignLiveRESTAPIHelper.ESignLiveRestAPIHelperException('Error send Sms To Signer ' + response.getStatusCode() + ' - ' + response.getStatus() + ' - ' +  response.getBody());
        }
    
    }
    
    public String createDraftPackage() {
        ESignLiveSDK sdk = new ESignLiveSDK();
         
        //Create package
        ESignLiveAPIObjects.Package_x pkg = new ESignLiveAPIObjects.Package_x();
        pkg.name = 'Test Signer Authentication - ' + Datetime.now().format();
        pkg.status = ESignLiveAPIObjects.PackageStatus.DRAFT;
        
        //Create Roles
        String roleId1 = 'signer1';
        String roleId2 = 'signer2';
        ESignLiveAPIObjects.Role signer1 = createSignerWithAuthentication_QA(roleId1,'John','Smith','signer1@mailinator.com','first question','first question answer','second question','second question answer');
        ESignLiveAPIObjects.Role signer2 = createSignerWithAuthentication_SMS(roleId2,'Duo','Liang','signer2@mailinator.com','+15145719967');
        
        pkg.roles = new List<ESignLiveAPIObjects.Role>{signer1,signer2};    //add role
        
        
        //Prepare Documents Blob
        String document1Name = 'Sample Document';
        StaticResource sr = [SELECT Id, Body FROM StaticResource WHERE Name = 'testdoc1' LIMIT 1];
        Map<String,Blob> documentBlobMap = new Map<String,Blob>();
        documentBlobMap.put(document1Name, sr.Body);
         
        //Create Document Metadata
        ESignLiveAPIObjects.Document document1 = new ESignLiveAPIObjects.Document();
        document1.name = document1Name;
        document1.id = 'document1';
         
        //Create Field &Approval
        ESignLiveAPIObjects.Field field1 = new ESignLiveAPIObjects.Field();
        field1.left = 208;
        field1.width = 200;
        field1.height = 50;
        field1.top = 518;
        field1.page = 0;
        field1.subtype = 'FULLNAME';
        field1.type = 'SIGNATURE';
         
        ESignLiveAPIObjects.Approval approval1 = new ESignLiveAPIObjects.Approval();
        approval1.fields = new List<ESignLiveAPIObjects.Field>{field1};    //add field
        approval1.role = roleId1;
        
        ESignLiveAPIObjects.Field field2 = new ESignLiveAPIObjects.Field();
        field1.left = 208;
        field1.width = 200;
        field1.height = 250;
        field1.top = 518;
        field1.page = 0;
        field1.subtype = 'FULLNAME';
        field1.type = 'SIGNATURE';
         
        ESignLiveAPIObjects.Approval approval2 = new ESignLiveAPIObjects.Approval();
        approval2.fields = new List<ESignLiveAPIObjects.Field>{field2};    //add field
        approval2.role = roleId2;
        
        
        document1.approvals = new List<ESignLiveAPIObjects.Approval>{approval1,approval2};    //add approval
        
        
        
        
        pkg.documents = new List<ESignLiveAPIObjects.Document>{document1};    //add document
        
        //Send package One Step
        String packageId = sdk.createPackage(pkg,documentBlobMap);
        System.debug('PackageId: ' + packageId);
        
        return packageId;
    }
    
    
    
    private HttpResponse doPost(String resourceUrl, String requestBody)
    {
        e_SignLive_Connection_Settings__c connectionSettings = e_SignLive_Connection_Settings__c.getInstance('Main');    
        //Cleanup requestBody string before sending it out
        String outboundRequestBody = ESignLiveJSONHelper.prepareOutboundJSON(requestBody);
        System.debug('=> outboundRequestBody:'+outboundRequestBody);

        // Build Request
        HttpRequest request = new HttpRequest();

        request.setEndpoint(connectionSettings.Endpoint__c + resourceUrl);
        request.setBody(outboundRequestBody);
        request.setMethod('POST');
        request.setHeader('Authorization', 'Basic ' + connectionSettings.API_Key__c);
        request.setHeader('Content-type', 'application/json');
        request.setHeader('Accept', 'application/json');

        // Send Request
        HttpResponse response = (new Http()).send(request);

        return response;
    }
    
}